//Shared variables
global int n_sides; // number of sides in the polygon. Unity -> ChucK
global float theta; // angle that acts as "playhead". Updates here in ChucK then sent to Unity, dictates positions/rotations!
global float bpm; // bpm. Updates in Unity, sent here to ChucK
Event e;


120.0 => bpm;
0.0 => theta; //a way to keep track of position/progress through a full revolution. RADIAN
6 => n_sides; // number of sides
25.0 => float updateRate; // in ms

((60.0 * 4.0 * 1000.0) / bpm) => float T; //time it takes (in ms) to complete a full revolution
(2*Math.PI * updateRate)/T => float rotateTick; // degrees for each update (10ms)


2*Math.PI/n_sides => float interval; // degrees between each 'hit'

// synth init
SinOsc osc => ADSR adsr => LPF lpf => Gain g => dac;
osc.gain(.25);
osc.freq(440);
adsr.set(10::ms, 100::ms, 0.0, 50::ms);
lpf.freq(2500);
g.gain(.5);


// updates the global playheadPos with fine granularity,
// for visualizing the playhead smoothly in Unity
/*
fun float AdvanceTime()
{
    while(true)
    {
        if(theta < 360.0)
        {
            if(theta % interval == 0.0)
            {
                osc.freq(440.0);
                adsr.keyOn();
            }
            theta + rotateTick => theta;
            updateRate::ms => now;
        }
        else
        {
            0.0 => theta;
            updateRate::ms => now;
        }
        <<<theta>>>;
    }
}
*/

fun float AdvanceTime()
{
    while(true)
    {
        0.0 => theta;
        osc.freq(440.0);
        adsr.keyOn();
        updateRate::ms => now;
    }
}


class Polygon
{
    int _n;
    float _theta, _interval;
    false => int isSet;
    
    fun void set(int n, float theta)
    {
        n => _n;
        theta => _theta;
        2*Math.PI / n => _interval;
        true => isSet;
    }
    fun float tick(float theta)
    {
        if(theta % _interval == 0.0)
        {
            osc.freq(440.0);
            adsr.keyOn();
        }
    }
    
}

Polygon poly;
poly.set(6, theta);
while(true)
{
    poly.tick(theta);
    //<<<theta>>>;
    theta + rotateTick => theta;
    updateRate::ms => now;
}
/*
SinOsc osc[n_sides] => ADSR adsr[n_sides] => LPF lpf[n_sides] => Gain g[n_sides] => dac;
for(0 => int i; i < n_sides; i++)
{
    osc[i].gain(.05);
    osc[i].freq(440 + i*10);
    adsr[i].set(10::ms, 300::ms, 0.0, 150::ms);
    lpf[i].freq(2500);
    g[i].gain(.2); 
}






spork ~ AdvanceTime();
while(true)
{
    1::second => now;
}
*/