// number of vertices (MUST match the Unity NUM_VERTICES!)
//4 => int NUM_VERTICES;
//BPM
120 => float bpm;
((60.0 / bpm ) * 1000.0)::ms => dur BEAT;
// update rate for pos
10::ms => dur POS_RATE;
// increment per step
POS_RATE/BEAT => float posInc;

// global (outgoing) variables for Unity animation
global int currentVertex; // which vertex we are at
// will take on fractional values for smooth animation[0-NUM_VERTICES)
global float playheadPos;

// global (incoming) data from Unity
4 => global int NUM_VERTICES;
global int editWhich;
1 => global float editRate;
1 => global float editGain;
global Event editHappened;
global Event nEdit;

class Polygon
{
    int _N;
    false => _isActive;
    false => int isSet;
    
    
    fun void set(int N)
    {
        N => _N;
        true => isActive;
        true => isSet;
    }
    
    fun void reset()
    {
        false => isActive;
        false => isSet;
    }
    
    fun void edit(float editRate, float editGain, int which)
    {
        
    }
    
    fun void go()
    {
        while ( isActive == true)
        {
            if(!isSet)
            {
                <<<"polygon hasn't been set yet">>>;
                me.exit()
            }
            else
            {
                //
                // PLAYBACK INITIALIZATION
                // containers for rates, gains for each vertex
                float seqRate[_N];
                float seqGain[_N];
                // sound buffers
                SndBuf bufs[_N];
                // reverb
                NRev reverb => dac;
                // reverb mix
                .1 => reverb.mix;
                for( int i; i < _N; i++ )
                {
                    1 => seqGain[i];
                    1 => seqRate[i];
                    
                    // connect to dac
                    bufs[i] => reverb;
                    // load sound
                    me.dir() + "data/snare.wav" => bufs[i].read;
                    // silence
                    0 => bufs[i].gain;
                }
                
                
                // PLAY CURRENT VERTEX
                
                // start from beginning of clip
                0 => bufs[currentVertex].pos;
                // set gain
                seqGain[currentVertex] => bufs[currentVertex].gain;
                // set rate
                seqRate[currentVertex] => bufs[currentVertex].rate;
                
                // sync with discrete grid position
                currentVertex => playheadPos;
                // advance time by duration of one beat 
                BEAT => now;
                // increment to next chicken
                currentVertex++;
                // wrap
                if( currentVertex >= N ) 0 => currentVertex; // originally NUM_VERTICES 
            }
        }
    }
}    
Polygon quad;
quad.set(NUM_VERTICES)

// spork update
spork ~ playheadPosUpdate();
// spork edit listener
spork ~ listenForEdit();
spork ~ listenForNEdit();


// updates the global playheadPos with fine granularity,
// for visualizing the playhead smoothly in Unity
fun void playheadPosUpdate()
{
    while( true )
    {
        // increment
        posInc +=> playheadPos;
        //<<<playheadPos>>>;
        // advance time
        POS_RATE => now;
    }
}


// this listens for events from Unity to update the sequence
fun void listenForEdit()
{
    while( true )
    {
        // wait for event
        editHappened => now;
        // update the gain and rate
        editRate => seqRate[editWhich];
        editGain => seqGain[editWhich];
        <<< "EDIT rate:", editRate, "gain:", editGain >>>;
    }
}

fun void listenForNEdit()
{
    while( true )
    {
        // wait for event
        nEdit => now;
        // update n
        //num_vertices => NUM_VERTICES;
        init(num_vertices);
        <<< num_vertices >>>;

    }
}